# Summary

[Introduction](./README.md)

# Getting Started

* [Installation](getting-started/installation.md)
* [First Steps with Starknet Foundry](getting-started/first-steps.md)
* [Scarb](getting-started/scarb.md)

# Projects

* [Project Configuration](projects/configuration.md)

# Forge overview

* [Running Tests](testing/running-tests.md)
* [Writing Tests](testing/testing.md)
* [Testing Smart Contracts](testing/contracts.md)
* [Debugging](testing/debugging.md)

# Interacting with Starknet

* [Overview](starknet/index.md)
* [Declaring New Contracts](starknet/declare.md)
* [Deploying New Contracts](starknet/deploy.md)
* [Invoking Contracts](starknet/invoke.md)
* [Calling Contracts](starknet/call.md)

# Foundry Development

* [Environment Setup](development/environment-setup.md)

# Appendix

* [Forge Command](appendix/forge.md)
* [Forge Library Functions References](appendix/forge-library.md)
    * [declare](appendix/forge-library/declare.md)
    * [deploy](appendix/forge-library/deploy.md)
    * [print](appendix/forge-library/print.md)
* [Cast Commands](appendix/cast.md)
    * [common flags](appendix/cast/common.md)
    * [declare](appendix/cast/declare.md)
    * [deploy](appendix/cast/deploy.md)
    * [invoke](appendix/cast/invoke.md)
    * [call](appendix/cast/call.md)
    * [multicall](appendix/cast/multicall.md)
